
$fn=72;

module body (sq=21, rd=14, ro=0, vyska=1) {
    coff=(ro==0)?rd/2:ro;
    union() {
        cube([sq,sq,vyska],true);
        translate([0,coff,0]) cylinder(d=rd,h=vyska, center=true);
        translate([0,-coff,0]) cylinder(d=rd,h=vyska, center=true);
        translate([coff,0,0]) cylinder(d=rd,h=vyska, center=true);
        translate([-coff,0,0]) cylinder(d=rd,h=vyska, center=true);
    }
}

module kasna() {

    difference() {
        union () {
            translate([0,0,-0.5]) body(sq=21, rd=14, vyska=11.5, ro=6);
            translate([0,0,-4.5]) body(sq=22, rd=15, vyska=1, ro=6);
            translate([0,0,0]) minkowski () {
                body(sq=21, rd=14, vyska=.001, ro=6);
                sphere(d=1);
            }
            translate([0,0,3]) minkowski () {
                body(sq=21, rd=14, vyska=.001, ro=6);
                sphere(d=1);
            }
        }
        body(sq=19, rd=12, vyska=100);
    }
    difference () {
        translate([0,0,-5.5]) body(sq=30, rd=18, vyska=1.5);
        translate([0,0,-1.2]) cube([6.2,6.2,8],true);
    }
}

module kasna_stlp() {
    translate([0,0,9]) cube([5,5,18],true);

    translate([0,0,13.5]) minkowski () {
        cube([5,5,0.001],true);
        sphere(d=1);
    }

    translate([0,0,4]) cube([6,6,8],true);
    translate([0,0,0.15]) {
        difference() {
            cylinder(d=13, h=0.3, center=true);
            cylinder(d=10, h=3, center=true);
        }
        cube([2,11.5,0.3],true);
        cube([11.5,2,0.3],true);
    }
}

module kasna_sokel() {
    difference() {
       body(sq=24, rd=17, vyska=1, ro=6);
        body(sq=19, rd=12, vyska=100);
    }
}


/**********************************************
Kompletna zostava
**********************************************/
translate([0,0,5.75])  kasna();
translate([0,0,1])  kasna_stlp();
translate([0,0,2*5.75]) kasna_sokel();
